%global __brp_check_rpaths %{nil}
%global __requires_exclude ^libmpi
%global packname  speakeasyR
%global packver   0.1.4
%global rlibdir   /usr/local/lib/R/library

Name:             R-CRAN-%{packname}
Version:          0.1.4
Release:          1%{?dist}%{?buildtag}
Summary:          Fast and Robust Multi-Scale Graph Clustering

License:          GPL (>= 3)
URL:              https://cran.r-project.org/package=%{packname}
Source0:          %{url}&version=%{packver}#/%{packname}_%{packver}.tar.gz


BuildRequires:    R-devel
Requires:         R-core
BuildRequires:    R-CRAN-Matrix 
BuildRequires:    R-methods 
Requires:         R-CRAN-Matrix 
Requires:         R-methods 

%description
A graph community detection algorithm that aims to be performant on large
graphs and robust, returning consistent results across runs. SpeakEasy 2
(SE2), the underlying algorithm, is described in Chris Gaiteri, David R.
Connell & Faraz A. Sultan et al. (2023) <doi:10.1186/s13059-023-03062-0>.
The core algorithm is written in 'C', providing speed and keeping the
memory requirements low. This implementation can take advantage of
multiple computing cores without increasing memory usage. SE2 can detect
community structure across scales, making it a good choice for biological
data, which often has hierarchical structure. Graphs can be passed to the
algorithm as adjacency matrices using base 'R' matrices, the 'Matrix'
library, 'igraph' graphs, or any data that can be coerced into a matrix.

%prep
%setup -q -c -n %{packname}

# fix end of executable files
find -type f -executable -exec grep -Iq . {} \; -exec sed -i -e '$a\' {} \;
# prevent binary stripping
[ -d %{packname}/src ] && find %{packname}/src -type f -exec \
  sed -i 's@/usr/bin/strip@/usr/bin/true@g' {} \; || true
[ -d %{packname}/src ] && find %{packname}/src/Make* -type f -exec \
  sed -i 's@-g0@@g' {} \; || true
# don't allow local prefix in executable scripts
find -type f -executable -exec sed -Ei 's@#!( )*/usr/local/bin@#!/usr/bin@g' {} \;

%build

%install

mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css
# remove buildroot from installed files
find %{buildroot}%{rlibdir} -type f -exec sed -i "s@%{buildroot}@@g" {} \;

%files
%{rlibdir}/%{packname}
